fileInFolder = function(folderName, fileName)
	if not file.exists(folderName) then
		print "Folder """ + folderName + """ not found."
		exit
	end if
	return file.child(folderName, fileName)
end function

//initialize var
checkCount = 0
failCount = 0
obj_num=200
erase_buf=240

picture = file.loadImage(fileInFolder("images", "bullet32.png"))

bul_col= ["#000000", "#FFFFFF"]

//class define
CBullet = {"number":0, "x":0, "y":0, "dx":0, "dy":0, "isactive":0}

CBullet.initialize=function( x, y, dx, dy, isactive)
	self.x=x
	self.y=y
	self.dx=dx
	self.dy=dy
	self.isactive=1
end function

CBullet.clear=function()
	self.x=0
	self.y=0
	self.dx=0
	self.dy=0
	self.isactive=0
end function

CBullet.update=function()
	self.x = self.x+self.dx
	self.y = self.y+self.dy

	//self.erase_check()
end function

CBullet.erase_check=function()
	if self.x>480+erase_buf then
		self.clear()
	end if

	if self.x<0+erase_buf then
		self.clear()
	end if

	if self.y>640 then
		self.clear()
	end if

	if self.y<0 then
		self.clear()
	end if

end function

CBullet.random_init= function()
	self.x=240+erase_buf
	self.y=480
	self.dx = ((rnd * 100)-50)*0.1
	self.dy = ((rnd * 100)-50)*0.1
	self.isactive=1
end function

CBullet.deg_init= function( deg=0 )
	self.x=240+erase_buf
	self.y=480
	spd = 2
	self.dx = cos(deg)*spd
	self.dy = sin(deg)*spd
	self.isactive=1
end function

CBullet.draw=function()
	gfx.fillRect pbul[i].x, pbul[i].y, 10, 10, bul_col[1]
end function


bg_draw=function(frm=0)
		buf_x=480
		buf_y=320
		a=frm%90*8
		b=frm%120*8
		rad_one = 3.1415926535 /180

		gfx.line buf_x+a*cos((90+frm*2)*rad_one),buf_y+a*sin((90+frm*2)*rad_one), 
				buf_x+a*cos((210+frm*2)*rad_one),buf_y+a*sin((210+frm*2)*rad_one)
		gfx.line buf_x+a*cos((210+frm*2)*rad_one),buf_y+a*sin((210+frm*2)*rad_one),
				buf_x+a*cos((330+frm*2)*rad_one),buf_y+a*sin((330+frm*2)*rad_one)
		gfx.line buf_x+a*cos((330+frm*2)*rad_one),buf_y+a*sin((330+frm*2)*rad_one),
				buf_x+a*cos((90+frm*2)*rad_one),buf_y+a*sin((90+frm*2)*rad_one)


		gfx.line buf_x+b*cos((90-frm*2)*rad_one),buf_y+b*sin((90-frm*2)*rad_one), 
				buf_x+b*cos((210-frm*2)*rad_one),buf_y+b*sin((210-frm*2)*rad_one)
		gfx.line buf_x+b*cos((210-frm*2)*rad_one),buf_y+b*sin((210-frm*2)*rad_one),
				buf_x+b*cos((330-frm*2)*rad_one),buf_y+b*sin((330-frm*2)*rad_one)
		gfx.line buf_x+b*cos((330-frm*2)*rad_one),buf_y+b*sin((330-frm*2)*rad_one),
				buf_x+b*cos((90-frm*2)*rad_one),buf_y+b*sin((90-frm*2)*rad_one)
end function

//display mode change
//self_graph=[gfx, g]

//gfx.clear

//Initialize
//fps cnt
prev_time=time()
fps = 0

//bullet definition
pbul=[]
pspr=[]

pbul2=[]
pspr2=[]

pbul3=[]
pspr3=[]

pbul4=[]
pspr4=[]

for i in range(0, obj_num)
    noob = new CBullet
    pbul.push noob
    noob.clear  //clear or initialize
    noob.number = i

    sp = new Sprite
    //pspr.push sp
    sp.image=picture //loadimage
    sp.x=i*5
    sp.y=-60
    sp.scale=0.5

    sprites.push sp //register sprites

    noob2 = new CBullet
    pbul2.push noob2
    noob2.clear  //clear or initialize
    noob2.number = i

    sp2 = new Sprite
    //pspr2.push sp2
    sp2.image=picture //loadimage
    sp2.x=i*5
    sp2.y=-60
    sp2.scale=0.5
	
    sprites.push sp2 //register sprites

    noob3 = new CBullet
    pbul3.push noob3
    noob3.clear  //clear or initialize
    noob3.number = i

    sp3 = new Sprite
    //pspr3.push sp3
    sp3.image=picture //loadimage
    sp3.x=i*5
    sp3.y=-60
    sp3.scale=0.5
	
    sprites.push sp3 //register sprites

    noob4 = new CBullet
    pbul4.push noob4
    noob4.clear  //clear or initialize
    noob4.number = i

    sp4 = new Sprite
    //pspr4.push sp4
    sp4.image=picture //loadimage
    sp4.x=i*5
    sp4.y=-60
    sp4.scale=0.5
	
    sprites.push sp4 //register spritesend for
end for

frame = 0
move_bullet=0

while not key.pressed("return")
	add_flag = 0
	move_bullet=0

	for i in range(0,obj_num)
		test = pbul[i]
		tsp  = sprites[i]

		if test.isactive == 0 then
			if add_flag ==0 then
				//pbul[i].random_init()
				test.deg_init(frame)
				//end for loop
				add_flag = 1
			end if
		else if test.isactive == 1 then
			//動作更新
			test.update()

			//消去確認
			if frame%2==1 then
				test.erase_check()
			end if				

			tsp.x = test.x
			tsp.y = test.y

			move_bullet=move_bullet+1
		end if

		pbul[i] = test
		sprites[i] = tsp

		// test2 = pbul2[i]
		// tsp2  = sprites[obj_num-1 + i]

		// if test2.isactive == 0 then
		// 	if add_flag ==0 then
		// 		//pbul[i].random_init()
		// 		test2.deg_init(frame)
		// 		//end for loop
		// 		add_flag = 1
		// 	end if
		// else if test2.isactive == 1 then
		// 	//動作更新
		// 	//test2.update()

		// 	//消去確認
		// 	if frame%2==1 then
		// 		test2.erase_check()
		// 	end if				

		// 	tsp2.x = test2.x
		// 	tsp2.y = test2.y

		// 	move_bullet=move_bullet+1
		// end if

		// pbul2[i] = test2
		// sprites[obj_num-1+i] = tsp2

		// test3 = pbul3[i]
		// tsp3  = sprites[obj_num*2-1 + i]

		// if test3.isactive == 0 then
		// 	if add_flag ==0 then
		// 		//pbul[i].random_init()
		// 		test3.deg_init(frame)
		// 		//end for loop
		// 		add_flag = 1
		// 	end if
		// else if test3.isactive == 1 then
		// 	//動作更新
		// 	//test3.update()

		// 	//消去確認
		// 	if frame%2==1 then
		// 		test3.erase_check()
		// 	end if				

		// 	tsp3.x = test3.x
		// 	tsp3.y = test3.y

		// 	move_bullet=move_bullet+1
		// end if

		// pbul3[i] = test3
		// sprites[obj_num*2-1+i] = tsp3

		// test4 = pbul4[i]
		// tsp4  = sprites[obj_num*3-1 + i]

		// if test4.isactive == 0 then
		// 	if add_flag ==0 then
		// 		//pbul[i].random_init()
		// 		test4.deg_init(frame)
		// 		//end for loop
		// 		add_flag = 1
		// 	end if
		// else if test4.isactive == 1 then
		// 	//動作更新
		// 	//test4.update()

		// 	//消去確認
		// 	if frame%2==1 then
		// 		test4.erase_check()
		// 	end if				

		// 	tsp4.x = test4.x
		// 	tsp4.y = test4.y

		// 	move_bullet=move_bullet+1
		// end if

		// pbul4[i] = test4
		// sprites[obj_num*3-1 + i] = tsp4

	end for

	//end if

	//draw bg
	if frame %2 ==0 then
		gfx.clear
		bg_draw(frame)
	end if

	//time calcurate
	if time()-prev_time>1.0 then
		fps=fps+1
		text.clear
		print "FPS : "+fps
		print "bullet : "+move_bullet
		fps=0
		prev_time=time()
	else
		fps=fps+1
	end if
	
	// if frame ==120 then
	// sprites.pop
	// end if
	
	frame=frame+1
	
	//yield
end while

